// Interpolator.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdlib.h>
#include <malloc.h>
#include <conio.h>
#include <string.h>
#include <math.h>

#define FREE(x) (free(x), x=NULL)

inline double abs(double val)
{
	if ( val < 0 ) return 0-val; else return val;
}

#include "matrixandvector.h"
#include "lup.h"

int main(int argc, char* argv[])
{
	Matrix A, L, U;
	Vector pi, b, x;
	char temp[1024];
	char iatemp[20];
	int degree, t, tt;
	double tval;

	printf("\nInterpolator\n");
	printf("============\n\n");

	printf("Which degree? ");
	gets(temp);
	degree=atoi(temp)+1;
	
	printf("\n");

	if ( degree < 2 ) {
		printf("Sorry, but this is not for constants (or negative degrees for that matter)!");
		exit(0);
	}

	A.init(degree, degree);
	b.init(degree, false);

	for(t=1; t<=degree; t++) {
		strcpy(temp, "X-value ");
		strcat(temp, _itoa(t, iatemp, 10));
		strcat(temp, ": ");
		printf(temp);
		gets(temp);
		tval=atof(temp);
		for(tt=1; tt<=degree; tt++)
			A.set(t,tt, pow(tval, tt-1));

		strcpy(temp, "Y-value ");
		strcat(temp, _itoa(t, iatemp, 10));
		strcat(temp, ": ");
		printf(temp);
		gets(temp);
		b[t]=atof(temp);

		printf("\n");
	}

	printf("\nBeginning\n");
	printf("---------\n\n");

	printf("A:\n");
	A.disp();
	printf("\n");

	printf("b:\n");
	b.disp();
	printf("\n");

	_getch();

	printf("\nLUP Decomposition\n");
	printf("-----------------\n\n");

	LUP_Decomposition(A, L, U, pi);

	printf("A:\n");
	A.disp();
	printf("\n");

	printf("L:\n");
	L.disp();
	printf("\n");

	printf("U:\n");
	U.disp();
	printf("\n");

	printf("pi:\n");
	pi.disp();
	printf("\n");

	_getch();

	printf("\nLUP Solve\n");
	printf("---------\n\n");

	LUP_Solve(L, U, pi, b, x);

	printf("x:\n");
	x.disp();
	printf("\n");

	return 0;
}

