
void LUP_Decomposition(Matrix &A, Matrix &L, Matrix &U, Vector &pi)
{
	int n;
	int i, k, k2, j;
	double t, p;

	Matrix A2;
	A2=A;

	n=A2.height();

	pi.init(n, true);

	for(i=1; i<=n; i++)
		pi[i]=i;

	for(k=1; k<n; k++) {
		p=0;
		for(i=k; i<=n; i++) {
			if ( abs(A2.e(i,k)) > p ) {
				p=abs(A2.e(i,k));
				k2=i;
			}
		}
		if ( p == 0 ) {
			printf("Singular matrix");
			exit(0);
		}
		t=pi[k];
		pi[k]=pi[k2];
		pi[k2]=t;
		for(i=1; i<=n; i++) {
			t=A2.e(k,i);
			A2.set(k,i, A2.e(k2,i));
			A2.set(k2,i, t);
		}
		for(i=k+1; i<=n; i++) {
			A2.set(i,k, A2.e(i,k)/A2.e(k,k));
			for(j=k+1; j<=n; j++)
				A2.set(i,j, A2.e(i,j) - (A2.e(i,k)*A2.e(k,j)));
		}
	}

	L.init(n,n);
	U.init(n,n);
	for(i=1; i<=n; i++) {
		for(j=1; j<i; j++) {
			L.set(i,j, A2.e(i,j));
			U.set(i,j, 0);
		}
		for(j=i; j<=n; j++) {
			L.set(i,j, 0);
			U.set(i,j, A2.e(i,j));
		}
		L.set(i,i, 1);
	}
}

void LUP_Solve(Matrix &L, Matrix &U, Vector &pi, Vector &b, Vector &x)
{
	int n, i, j;
	Vector y;
	
	n=L.height();
	y.init(n, true);
	x.init(n, false);

	for(i=1; i<=n; i++) {
		y[i]=b[(int)pi[i]];
		for(j=1; j<i; j++)
			y[i]-=L.e(i,j)*y[j];
	}
	for(i=n; i>=1; i--) {
		x[i]=y[i];
		for(j=i+1; j<=n; j++)
			x[i]-=U.e(i,j)*x[j];
		x[i]/=U.e(i,i);
	}
}
